﻿// Nombre de archivo particleSys.as
class particleSys extends MovieClip {
	// Definir los tipos y los nombres de propiedad
	//var dependiente:Boolean;
	var numeroParticulas:Number;
	var velocidad:Number;
	var factorFriccion:Number;
	var life:Number;
	var particulaClip:String;
	var elLugar:MovieClip;
	var gravedad:Number;
	var opacity:Boolean;
	//
	// La línea siguiente es el constructor (y por ello tiene el nombre de la clase)
	function particleSys(imp_particulaClip:String, imp_lugar:MovieClip) {
		//dependiente = true;
		numeroParticulas = 40;
		velocidad = 2;
		factorFriccion = 0;
		life = 10;
		particulaClip = imp_particulaClip;
		this.elLugar = imp_lugar;
		gravedad = 3;
		opacity = true;
		//
	}
	// Crear métodos para volver a ejecutar los valores de propiedad
	function createSparks() {
		for (var i = 1; i<=numeroParticulas; i++) {
			this.elLugar.attachMovie(particulaClip, "spark"+i, i);
			this.elLugar["spark"+i].iniX = this.elLugar._x;
			this.elLugar["spark"+i].iniY = this.elLugar._y;
			this.elLugar["spark"+i]._x = this.elLugar["spark"+i].iniX-this.elLugar._x;
			this.elLugar["spark"+i]._y = this.elLugar["spark"+i].iniY-this.elLugar._y;
			this.elLugar["spark"+i].velocidad = random(velocidad-1)+1;
			this.elLugar["spark"+i].angulo = Math.PI/180*(random(360));
			this.elLugar["spark"+i].life = 0;
			this.elLugar["spark"+i].lifeLimit = random(life)+1;
			//
		}
	}
	function updateSparks() {
		for (var i = 1; i<=numeroParticulas; i++) {
			//recalculamos su velocidad (global) debido a la friccion
			this.elLugar["spark"+i].velocidad = this.elLugar["spark"+i].velocidad-factorFriccion;
			if (this.elLugar["spark"+i].velocidad<0) {
				this.elLugar["spark"+i].velocidad = 0;
			}
			//recalculamos la opacidad de la particula (spark) segun la vida ke lleva
			if (opacity == true) {
				var opacFactor = 100/this.elLugar["spark"+i].lifeLimit;
				this.elLugar["spark"+i]._alpha -= opacFactor;
			}
			//descomponemos la velocidad en los dos ejes X,Y
			var velX = Math.cos(this.elLugar["spark"+i].angulo)*this.elLugar["spark"+i].velocidad;
			var velY = Math.sin(this.elLugar["spark"+i].angulo)*this.elLugar["spark"+i].velocidad;
			this.elLugar["spark"+i]._x = (this.elLugar["spark"+i].iniX-this.elLugar._x)+velX;
			this.elLugar["spark"+i]._y = (this.elLugar["spark"+i].iniY-this.elLugar._y)+velY+gravedad;
			this.elLugar["spark"+i].iniX+=velX;
			this.elLugar["spark"+i].iniY+=velY+gravedad;
			this.elLugar["spark"+i].life++;
			//en caso de ke la particula deba "morir" eliminamos la particula y generamos otra
			if (this.elLugar["spark"+i].life == this.elLugar["spark"+i].lifeLimit or this.elLugar["spark"+i].velocidad<=0 or this.elLugar["spark"+i]._alpha<=0) {
				this.elLugar.attachMovie(particulaClip, "spark"+i, i);
				this.elLugar["spark"+i].iniX = this.elLugar._x;
				this.elLugar["spark"+i].iniY = this.elLugar._y;
				this.elLugar["spark"+i]._x = this.elLugar["spark"+i].iniX-this.elLugar._x;
				this.elLugar["spark"+i]._y = this.elLugar["spark"+i].iniY-this.elLugar._y;
				this.elLugar["spark"+i].velocidad = random(velocidad-1)+1;
				this.elLugar["spark"+i].angulo = Math.PI/180*(random(360));
				this.elLugar["spark"+i].life = 0;
				this.elLugar["spark"+i].lifeLimit = random(life)+1;
			}
		}
	}
}
